var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n  flex: 1;\n  display: flex;\n'], ['\n  flex: 1;\n  display: flex;\n']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n  flex: 1;\n  display: flex;\n\n  > iframe {\n    flex: 1;\n    width: 100%;\n    height: 100%;\n    min-height: ', ' !important;\n    display: flex;\n    border: 0px;\n  }\n'], ['\n  flex: 1;\n  display: flex;\n\n  > iframe {\n    flex: 1;\n    width: 100%;\n    height: 100%;\n    min-height: ', ' !important;\n    display: flex;\n    border: 0px;\n  }\n']);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React, { Component } from 'react';
import Script from 'react-load-script';
import styled from 'styled-components';

var Wrapper = styled.div(_templateObject);

var Designer = styled.div(_templateObject2, function (props) {
  return props.minHeight || '500px';
});

var _default = function (_Component) {
  _inherits(_default, _Component);

  function _default() {
    var _temp, _this, _ret;

    _classCallCheck(this, _default);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.unrollReady = function () {
      unroll.init(_extends({}, _this.props.options || {}, {
        id: 'editor',
        displayMode: 'web'
      }));

      if (_this.props.design) {
        _this.loadDesign(_this.props.design);
      }
    }, _this.loadDesign = function (design) {
      unroll.loadDesign(design);
    }, _this.saveDesign = function (callback) {
      unroll.saveDesign(callback);
    }, _this.exportHtml = function (callback) {
      unroll.exportHtml(callback);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _default.prototype.render = function render() {
    return React.createElement(
      Wrapper,
      null,
      React.createElement(Script, {
        url: 'https://designer.unroll.io/assets/embed.bundle.js',
        onLoad: this.unrollReady
      }),
      React.createElement(Designer, {
        id: 'editor',
        style: this.props.style,
        minHeight: this.props.minHeight
      })
    );
  };

  return _default;
}(Component);

export { _default as default };